<?php
/*
	[UCenter Home] (C) 2007-2008 Comsenz Inc.
	$Id: index.php 13234 2009-08-24 08:20:04Z liguode $
*/

define('IN_UCHOME', TRUE);

error_reporting(0);
$_SGLOBAL = $_SCONFIG = $_SBLOCK = array();

//程序目录
define('S_ROOT', substr(dirname(__FILE__), 0, -7));

//获取时间
$_SGLOBAL['timestamp'] = time();

include_once(S_ROOT.'./source/function_common.php');
if(!@include_once(S_ROOT.'./config.php')) {
	@include_once(S_ROOT.'./config.new.php');
	show_msg('Please go to the root of your ucenter home installation, rename config.new.php to config.php, then run the installation wizard again.', 999);
}

//GPC过滤
if(!(get_magic_quotes_gpc())) {
	$_GET = saddslashes($_GET);
	$_POST = saddslashes($_POST);
}

//启用GIP
if ($_SC['gzipcompress'] && function_exists('ob_gzhandler')) {
	ob_start('ob_gzhandler');
} else {
	ob_start();
}

$formhash = formhash();

$theurl = 'index.php';
$sqlfile = S_ROOT.'./data/install.sql';
if(!file_exists($sqlfile)) {
	show_msg('Please upload the latest install.sql to /data, then run the installation wizard again.', 999);
}
$configfile = S_ROOT.'./config.php';

//变量
$step = empty($_GET['step'])?0:intval($_GET['step']);
$action = empty($_GET['action'])?'':trim($_GET['action']);
$nowarr = array('','','','','','','');

$lockfile = S_ROOT.'./data/install.lock';
if(file_exists($lockfile)) {
	show_msg('Warning! You have already installed UCenter Home<br>
		To ensure the safety of your data, please manually delete install/index.php <br>
		If you want to re-install UCenter Home, please delete the data/install.lock, login to UCenter admin end to remove the application, then run the installation wizard again.');
}

//检查config是否可写
if(!@$fp = fopen($configfile, 'a')) {
	show_msg("$configfile permission error, please CHMODE to writable, then run the installation wizard again.");
} else {
	@fclose($fp);
}

//提交处理
if (submitcheck('ucsubmit')) {

	//安装UC配置
	$step = 1;

	//判断域名是否解析
	$ucapi = preg_replace("/\/$/", '', trim($_POST['ucapi']));
	$ucip = trim($_POST['ucip']);

	if(empty($ucapi) || !preg_match("/^(http:\/\/)/i", $ucapi)) {
		show_msg('Incorrect UCenter URL');
	} else {
		//检查服务器 dns 解析是否正常, dns 解析不正常则要求用户输入ucenter的ip地址
		if(!$ucip) {
			$temp = @parse_url($ucapi);
			$ucip = gethostbyname($temp['host']);
			if(ip2long($ucip) == -1 || ip2long($ucip) === FALSE) {
				$ucip = '';
			}
		}
	}

	//验证UCHome是否安装
	if(!@include_once S_ROOT.'./uc_client/client.php') {
		show_msg('uc_client directory does not exist, please upload the installation package in ./upload/uc_client to the root of your ucenter home installation.');
	}
	$ucinfo = uc_fopen2($ucapi.'/index.php?m=app&a=ucinfo&release='.UC_CLIENT_RELEASE, 500, '', '', 1, $ucip);
	list($status, $ucversion, $ucrelease, $uccharset, $ucdbcharset, $apptypes) = explode('|', $ucinfo);
	$dbcharset = strtolower(trim($_SC['dbcharset'] ? str_replace('-', '', $_SC['dbcharset']) : $_SC['dbcharset']));
	$ucdbcharset = strtolower(trim($ucdbcharset ? str_replace('-', '', $ucdbcharset) : $ucdbcharset));
	$apptypes = strtolower(trim($apptypes));
	if($status != 'UC_STATUS_OK') {
		show_header();
		print<<<END
		<form id="theform" method="post" action="$theurl">
		<table class="datatable">
		<tr><td><strong>UCenter connection error, ( $status ), make sure that the IP address of UCenter is correct </strong><br><br></td></tr>
		<tr><td>UCenter IP address:<input type="text" name="ucip" value="$ucip"> For example:192.168.0.1</td></tr>
		</table>
		<table class=button>
		<tr><td>
		<input type="hidden" name="ucapi" value="$ucapi">
		<input type="hidden" name="ucfounderpw" value="$_POST[ucfounderpw]">
		<input type="submit" id="ucsubmit" name="ucsubmit" value="Submit"></td></tr>
		</table>
		<input type="hidden" name="formhash" value="$formhash">
		</form>
END;
		show_footer();
		exit();
	} elseif($dbcharset && $ucdbcharset && $ucdbcharset != $dbcharset) {
		show_msg('Charset of UCenter server-side is different with current application, please download '.$Ucdbcharset.' encoding UCenter Home here: http://download.comsenz.com/');
	} elseif(strexists($apptypes, 'uchome')) {
		show_msg('You have already installed an UCenter Home, if you want to continue with the installation, please remove the application in admin end of UCenter!');
	}
	$tagtemplates = 'apptagtemplates[template]='.urlencode('<a href="{url}" target="_blank">{subject}</a>').'&'.
		'apptagtemplates[fields][subject]='.urlencode('Blog Title').'&'.
		'apptagtemplates[fields][uid]='.urlencode('User ID').'&'.
		'apptagtemplates[fields][username]='.urlencode('Username').'&'.
		'apptagtemplates[fields][dateline]='.urlencode('Date').'&'.
		'apptagtemplates[fields][spaceurl]='.urlencode('Space URL').'&'.
		'apptagtemplates[fields][url]='.urlencode('Blog URL');

	$uri = $_SERVER['REQUEST_URI']?$_SERVER['REQUEST_URI']:($_SERVER['PHP_SELF']?$_SERVER['PHP_SELF']:$_SERVER['SCRIPT_NAME']);
	$app_url = strtolower(substr($_SERVER['SERVER_PROTOCOL'], 0, strpos($_SERVER['SERVER_PROTOCOL'], '/'))).'://'.$_SERVER['HTTP_HOST'].preg_replace("/\/*install$/i", '', substr($uri, 0, strrpos($uri, '/install')));

	$postdata = "m=app&a=add&ucfounder=&ucfounderpw=".urlencode($_POST['ucfounderpw'])."&apptype=".urlencode('UCHOME')."&appname=".urlencode('Personal Home')."&appurl=".urlencode($app_url)."&appip=&appcharset=".$_SC['charset'].'&appdbcharset='.$_SC['dbcharset'].'&release='.UC_CLIENT_RELEASE.'&'.$tagtemplates;
	$s = uc_fopen2($ucapi.'/index.php', 500, $postdata, '', 1, $ucip);
	if(empty($s)) {
		show_msg('UCenter connection error');
	} elseif($s == '-1') {
		show_msg('UCenter administrator password is incorrect');
	} else {
		$ucs = explode('|', $s);
		if(empty($ucs[0]) || empty($ucs[1])) {
			show_msg('UCenter returned data problems, please refer to:<br />'.shtmlspecialchars($s));
		} else {

			//处理成功
			$apphidden = '';
			//验证是否可以直接联接MySQL
			$link = mysql_connect($ucs[2], $ucs[4], $ucs[5], 1);
			$connect = $link && mysql_select_db($ucs[3], $link) ? 'mysql' : '';
			//返回
			foreach (array('key', 'appid', 'dbhost', 'dbname', 'dbuser', 'dbpw', 'dbcharset', 'dbtablepre', 'charset') as $key => $value) {
				if($value == 'dbtablepre') {
					$ucs[$key] = '`'.$ucs[3].'`.'.$ucs[$key];
				}
				$apphidden .= "<input type=\"hidden\" name=\"uc[$value]\" value=\"".$ucs[$key]."\" />";
			}
			//内置
			$apphidden .= "<input type=\"hidden\" name=\"uc[connect]\" value=\"$connect\" />";
			$apphidden .= "<input type=\"hidden\" name=\"uc[api]\" value=\"$_POST[ucapi]\" />";
			$apphidden .= "<input type=\"hidden\" name=\"uc[ip]\" value=\"$ucip\" />";

			show_header();
			print<<<END
			<form id="theform" method="post" action="$theurl">
			<table>
			<tr><td>UCenter successfully registered! ID of current program is : $ucs[1]</td></tr>
			</table>

			<table class=button>
			<tr><td>$apphidden
			<input type="submit" id="uc2submit" name="uc2submit" value="Next"></td></tr>
			</table>
			<input type="hidden" name="formhash" value="$formhash">
			</form>
END;
			show_footer();
			exit();
		}
	}

} elseif (submitcheck('uc2submit')) {

	//增加congfig配置
	$step = 2;

	//写入config文件
	$configcontent = sreadfile($configfile);
	$keys = array_keys($_POST['uc']);
	foreach ($keys as $value) {
		$upkey = strtoupper($value);
		$configcontent = preg_replace("/define\('UC_".$upkey."'\s*,\s*'.*?'\)/i", "define('UC_".$upkey."', '".$_POST['uc'][$value]."')", $configcontent);
	}
	if(!$fp = fopen($configfile, 'w')) {
		show_msg("$configfile permission error, please CHMODE to be writable, then run the installation wizard again.");
	}
	fwrite($fp, trim($configcontent));
	fclose($fp);

} elseif(!empty($_POST['sqlsubmit'])) {

	$step = 2;

	//先写入config文件
	$configcontent = sreadfile($configfile);
	$keys = array_keys($_POST['db']);
	foreach ($keys as $value) {
		$configcontent = preg_replace("/[$]\_SC\[\'".$value."\'\](\s*)\=\s*[\"'].*?[\"']/is", "\$_SC['".$value."']\\1= '".$_POST['db'][$value]."'", $configcontent);
	}
	if(!$fp = fopen($configfile, 'w')) {
		show_msg("$configfile permission error, please CHMODE to be writable, then run the installation wizard again.");
	}
	fwrite($fp, trim($configcontent));
	fclose($fp);
	
	if(empty($_POST['db']['tablepre'])) {
		show_msg("Table prefix can not be empty");
	}

	//判断UCenter Home数据库
	$havedata = false;
	if(!@mysql_connect($_POST['db']['dbhost'], $_POST['db']['dbuser'], $_POST['db']['dbpw'])) {
		show_msg('Database connection information error, please confirm');
	}
	if(mysql_select_db($_POST['db']['dbname'])) {
		if(mysql_query("SELECT COUNT(*) FROM {$_POST['db']['tablepre']}space")) {
			$havedata = true;
		}
	} else {
		if(!mysql_query("CREATE DATABASE `".$_POST['db']['dbname']."`")) {
			show_msg('Not authorized to operate on UCenter Home database, please check configuration file, then run the installation wizard again.');
		}
	}

	if($havedata) {
		show_msg('Dangerous! Specified UCenter Home database is not empty, current data will be DELETED if you continue!', ($step+1));
	} else {
		show_msg('Database configuration successful, go to next step', ($step+1), 1);
	}

} elseif (submitcheck('opensubmit')) {

	//检查用户身份
	include_once(S_ROOT.'./data/data_config.php');

	$step = 5;

	dbconnect();

	//同步获取用户源
	$_SGLOBAL['timestamp'] = time();

	//UC注册用户
	if(!@include_once S_ROOT.'./uc_client/client.php') {
		showmessage('system_error');
	}
	$uid = uc_user_register($_POST['username'], $_POST['password'], 'webmaster@yourdomain.com');
	if($uid == -3) {
		//已存在，登录
		if(!$passport = getpassport($_POST['username'], $_POST['password'])) {
			show_msg('Incorrect username or password, please confirm');
		}
		$setarr = array(
			'uid' => $passport['uid'],
			'username' => addslashes($passport['username'])
		);
	} elseif($uid > 0) {
		$setarr = array(
			'uid' => $uid,
			'username' => $_POST['username']
		);
	} else {
		show_msg('Username can not be registered, please confirm');
	}
	$setarr['password'] = md5("$setarr[uid]|$_SGLOBAL[timestamp]");//本地密码随机生成

	//更新本地用户库
	inserttable('member', $setarr, 0, true);

	//开通空间
	include_once(S_ROOT.'./source/function_space.php');
	$space = space_open($setarr['uid'], $_POST['username'], 1);

	//反馈受保护
	$result = uc_user_addprotected($_POST['username'], $_POST['username']);
	$_SGLOBAL['db']->query("UPDATE ".tname('space')." SET flag=1 WHERE username='$_POST[username]'");

	//清理在线session
	insertsession($setarr);

	//设置cookie
	ssetcookie('auth', authcode("$setarr[password]\t$setarr[uid]", 'ENCODE'), 2592000);

	//写log
	if(@$fp = fopen($lockfile, 'w')) {
		fwrite($fp, 'UCenter Home');
		fclose($fp);
	}

	show_msg('<font color="red">Congratulations! UCenter Home has been successfully installed!</font>
		<br>For the safety of your data, please use ftp to delete the install folder.<br><br>
		You have been identified as administrator and your space has been activated. Next, you can:<br>
		<br><a href="../space.php" target="_blank">Go to your space</a>
		<br>visit homepage and start UCenter Home Tour
		<br><a href="../admincp.php" target="_blank">Go to the management platform</a>
		<br>As an administrator you can set parameters of the site', 999);

}

if(empty($step)) {

	show_header();

	//检查权限设置
	$checkok = true;
	$perms = array();
	if(!checkfdperm(S_ROOT.'./config.php', 1)) {
		$perms['config'] = 'Failure';
		$checkok = false;
	} else {
		$perms['config'] = 'OK';
	}
	if(!checkfdperm(S_ROOT.'./attachment/')) {
		$perms['attachment'] = 'Failure';
		$checkok = false;
	} else {
		$perms['attachment'] = 'OK';
	}
	if(!checkfdperm(S_ROOT.'./data/')) {
		$perms['data'] = 'Failure';
		$checkok = false;
	} else {
		$perms['data'] = 'OK';
	}
	if(!checkfdperm(S_ROOT.'./uc_client/data/')) {
		$perms['uc_data'] = 'Failure';
		$checkok = false;
	} else {
		$perms['uc_data'] = 'OK';
	}

	//安装阅读
	print<<<END
	<script type="text/javascript">
	function readme() {
		var tbl_readme = document.getElementById('tbl_readme');
		if(tbl_readme.style.display == '') {
			tbl_readme.style.display = 'none';
		} else {
			tbl_readme.style.display = '';
		}
	}
	</script>
	<table class="showtable">
	<tr><td>
	<strong>Welcome to use UCenter Home</strong><br>
	UCenter Home is the most popular SNS in China, hundreds of thousands of SNS sites are built with it, also it is the best of same kind in the world.
	<br><a href="javascript:;" onclick="readme()"><strong>Please read our Software License Agreement carefully</strong></a>
	</td></tr>
	</table>

	<table>
	</td></tr>
	<tr><td>
	<strong>File/directory perm settings</strong><br>
	You need to set permissions of related files and directories before running the installation wizard.<br>
	Recommend that you do so: <br>FTP to your server, CHMODE the following directories and all the files in the directory to 777, if you are using windows host, set internet guest account has read-write perm.<br>
	<table class="datatable">
	<tr style="font-weight:bold;"><td>Name</td><td>Perm Required</td><td>Desc</td><td>Results</td></tr>
	<tr><td><strong>./config.php</strong></td><td>Read/Write</td><td>System   config</td><td>$perms[config]</td></tr>
	<tr><td><strong>./attachment/</strong> (Including dir, subdirs and all  files)</td><td>Read/write/delete</td><td>Attachment dir</td><td>$perms[attachment]</td></tr>
	<tr><td><strong>./data/</strong> (Including dir, subdirs and all files)</td><td>Read/write/delete</td><td>Site Data Directory</td><td>$perms[data]</td></tr>
	<tr><td><strong>./uc_client/data/</strong> (Including dir, subdirs and all  files)</td><td>Read/write/delete</td><td>uc_client Data Directory</td><td>$perms[uc_data]</td></tr>
	</table>
	</td></tr>
	</table>
END;

	if(!$checkok) {
		echo "<table><tr><td><b>Errors occurred</b>:<br>The system detected perm errors, the above directory or file permissions is not properly set up. <br> Strongly recommend you CHMODE dirs and files, refresh the page to continue with the installation. <br> Otherwise, the system may occurs unforeseen problems  [<a href=\"$theurl?step=1\">Forced to continue</a>]</td></tr></table>";
	} else {
		$ucapi = empty($_POST['ucapi'])?'/':$_POST['ucapi'];
		$ucfounderpw = empty($_POST['ucfounderpw'])?'':$_POST['ucfounderpw'];
		print <<<END
		<form id="theform" method="post" action="$theurl?step=1">
			<table class=button>
				<tr>
					<td><input type="submit" id="startsubmit" name="startsubmit" value="Accepted the license agreement,  proceed to install UCenter Home"></td>
				</tr>
			</table>
			<input type="hidden" name="ucapi" value="$ucapi" />
			<input type="hidden" name="ucfounderpw" value="$ucfounderpw" />
			<input type="hidden" name="formhash" value="$formhash">
		</form>
END;
	}

	print<<<END
	<table id="tbl_readme" style="display:none;" class="showtable">
	<tr>
	<td><strong>Please be sure to read the following license agreement carefully:</strong> </td></tr>
	<tr>
	<td>
<div class="license"><h1>English Version of EULA, for non-Chinese-Speaking Users Only</h1>
	
<p>This version of English UCenter Home is translated by Msg2me, the official traslation team of Comsenz products, please visit http://www.msg2me.com for updates.</p>	<p>Copyright (C) 2001-2009, Comsenz (Beijing) Technology Co., Ltd. <br> All rights reserved.
	</p><p>Thank you for choosing UCenter Home. We hope that our efforts can provide you with a powerful social networking (SNS) solution. By UCenter Home, webmasters can easily build a powerful communication network based on friends relationships, so that site users can record daily life in one sentence; publish blogs and upload pictures quickly and easily; share information, discuss topics of interest with friends conveniently; get to know friends news quickly and easily.
	</p><p>Comsenz (Beijing) Technology Co., Ltd. is the developer of UCenter Home, owns copyright of UCenter Home independently according to related laws (China\'s National Copyright Administration of Copyright Registration No. 2008SR09993). Website of Comsenz (Beijing) Technology Co., Ltd. is 
	http://www.comsenz.com, official website of UCenter Home is  http://u.discuz.net.
	</p><p>UCenter Home has been registered in National Copyright Bureau  of The People\'s Republic of China, protected by the law and international treaties. Users: whether individuals or organizations, profit or not, how to use (including study and research purposes), are required to read this agreement carefully, may start to us UCenter Home software only after fully understanding, agree to and comply with all the terms of this agreement .
	</p><p>Comsenz (Beijing) Technology Co., Ltd. owns the right of final interpretation of the license agreement.

<h3>I. Definitions</h3>
<ol>
<li>"Crossday UCenter Home"("UCenter Home" for short) is a Social Nework System which is developed by Comsenz Inc..</li>
<li>"the Software" means "Crossday UCenter Home".</li>
<li>"Comsenz Inc." is the enterprise being responsible for Discuz! product.</li>
<li>"Msg2me" - Comsenz (Discuz) Official Multilingual Support Team (http://www.msg2me.com), is a volunteer-driven quality-oriented software translation effort which anticipates that the value it provides to the community will result in contributions to keep it alive. All the translators do their work on Msg2me projects in their spare time. All msg2me translations are not allowed for commercial use without written permission, including but not limited to Comsenz and or any other parties.</li>

</ol>



<h3>II. License Grants</h3> 
<ol>

<li>You may use the Software for free for non-commercial use under the License Restrictions.</li>
<li>You may modify the source code(if being provieded) or interface of the Software to fit your website under the License Restrictions.</li>
<li>You have property of all members’ information and articles in the Bulletin Board powered by the Software; meanwhile, you need assume all relevant legal duty by yourself.</li>
<li>You may use the Software for commercial use after purchasing the commercial license. Moreover, according to the license you purchased you may get specified term, manner and content of technical support from Comsenz Inc. Commercial users are prior to submiting ideas and opinions to Comsenz Inc., but without any guarantee of acceptance.</li>
</ol>




<h3>III. License Restrictions</h3>
<ol>

<li>You may not use the Software for commercial use or profit use, unless you have been licensed to. To purchase the license, please visit http://www.discuz.com or dial 8610-5165 7885 for more information.</li>
<li>You may not rent, lease, sublicense, sell, assign, pledge the Software and its services.</li>
<li>You may not remove or modify the copyright information and relevant links, such as http://www.comsenz.com, http://www.discuz.com and http://www.discuz.net, in the footer of all web pages without the prior written consent of Comsenz Inc., no matter how heavily you modified the Software.</li>
<li>Upon usage of Msg2me multilingual translations [english and all other language versions provided by Msg2me], you may not remove or modify the copyright information and relevant links, such as http://www.msg2me.com, in the footer of all web pages without the prior written consent of msg2me.com, no matter how heavily you modified the Software.</li>
<li>You may not modify the Software to create derivative works for redistribution based upon the Software.</li>
<li>In the event that you fail to comply with this EULA, your license will be terminated.</li>
</ol>



<h3>IV. LIMITED WARRANTY AND DISCLAIMER</h3>
<ol>


<li>THE SOFTWARE AND THE ACCOMPANYING FILES ARE SOLD "AS IS" AND WITHOUT WARRANTIES AS TO PERFORMANCE OF MERCHANTABILITY OR ANY OTHER WARRANTIED WHETHER EXPRESSED OR IMPLIED.</li>
<li>Comsenz Inc. is not liable for the content of any message posted on the forums powered by the Software.</li>
<li>You must assume the entire risk of using the Software. ANY LIABILITY OF Comsenz Inc. WILL BE LIMITED EXCLUSIVELY TO PRODUCT REPLACEMENT, REFUND OF PURCHASE PRICE BEFORE YOUR FIRST INSTALLATION.</li>
</ol>



<h3>V. Official Websites</h3>
<ol>

<li>Comsenz Inc.: http://www.comsenz.com.</li>
<li>Discuz! Home: http://www.discuz.com</li>
<li>Discuz! Community: http://www.discuz.net</li>
<li>Comsenz Official Multilingual Support: http://www.msg2me.com</li>
</ol>


<p>Comsenz Inc. reserves the right to modify this EULA. Comsenz.com provides offical information on license and price, Comsenz Inc. may modify them without notice. Modified license and price list will apply to new licensed users.</p></div>
	</td></tr>
	</table>
END;

	show_footer();

} elseif($step == 1) {

	show_header();
	$ucapi = "http://";
	$ucfounderpw = '';
	$showdiv = 0;
	if($_POST['ucfounderpw']) {
		$showdiv = 1;
		$ucapi = trim($_POST['ucapi']);
		$ucfounderpw = trim($_POST['ucfounderpw']);
	}

	if($showdiv) {
		print<<<END
		<form id="theform" method="post" action="$theurl">
		<div>
			<table class="showtable">
				<tr><td><strong># UCenter parameter autofetch</strong></td></tr>
				<tr><td id="msg2">UCenter relevant information has been fetched, please click the button below to submit configuration</td></tr>
			</table>
			<br/>
		</div>
		<div>
END;
	} else {
		$plus = '';
		if(!$ucfounderpw) {
			$plus = '<tr><td id="msg2">
					To use UCenter Home, first you need to install an UCenter which consistent user account information is stored in.<br>
					If your site has not yet installed UCenter, please do this:<br>
					1. <a href="http://download.comsenz.com/UCenter/" target="_blank"><b>Please click here to download the latest version of the UCenter</b></a>，And read the instructions on the package UCenter installation.<br>
					2. UCenter installed after the UCenter fill in the following relevant information can proceed UCenter Home installation.<br>
				</td></tr>';
		}
		print<<<END
		<form id="theform" method="post" action="$theurl">
		<div>
			<table class="showtable">
				<tr><td><strong># Please fill in the relevant parameters UCente</strong></td></tr>
				$plus
			</table>
			<br>
			<p style="font-weight:bold;">Please enter the installed UCenter information:</p>
END;
	}
	print<<<END
		<table class=datatable>
			<tbody>
				<tr>
					<td>UCenter  URL:</td>
					<td><input type="text" id="ucapi" name="ucapi" size="60" value="$ucapi"><br>For example:http://www.discuz.net/ucenter</td>
				</tr>
				<tr>
					<td>UCenter the founder Password:</td>
					<td><input type="password" id="ucfounderpw" name="ucfounderpw" size="20" value="$ucfounderpw"></td>
				</tr>
			</tbody>
		</table>
		<br>
	</div>
	<table class=button>
	<tr><td><input type="submit" id="ucsubmit" name="ucsubmit" value="Configuration information submitted UCenter"></td></tr>
	</table>
	<input type="hidden" id="ucfounder" name="ucfounder" size="20" value="">
	<input type="hidden" name="formhash" value="$formhash">
	</form>
END;
	show_footer();

} elseif ($step == 2) {

	//检测目录属性
	show_header();
	//设置数据库配置
	print<<<END
	<form id="theform" method="post" action="$theurl">

	<table class="showtable">
	<tr><td><strong># Set UCenter Home Database Information</strong></td></tr>
	<tr><td id="msg1">Enter database info of UCenter Home</td></tr>
	</table>
	<table class=datatable>
	<tr>
	<td width="25%">DB Server address:</td>
	<td><input type="text" name="db[dbhost]" size="20" value="localhost"></td>
	<td width="30%">Usually localhost</td>
	</tr>
	<tr>
	<td>DB Username:</td>
	<td><input type="text" name="db[dbuser]" size="20" value=""></td>
	<td>&nbsp;</td>
	</tr>
	<tr>
	<td>DB Password:</td>
	<td><input type="password" name="db[dbpw]" size="20" value=""></td>
	<td>&nbsp;</td>
	</tr>
	<tr>
	<td>DB CharSet:</td>
	<td>
	<select name="db[dbcharset]" onchange="addoption(this)">
	<option value="$_SC[dbcharset]">$_SC[dbcharset]</option>
	<option value="addoption" class="addoption">+ Custom</option>
	</select>
	</td>
	<td>MySQL version >4.1</td>
	</tr>
	<tr>
	<td>DB Name:</td>
	<td><input type="text" name="db[dbname]" size="20" value=""></td>
	<td>Script will attempt to create automatically if it does not exist</td>
	</tr>
	<tr>
	<td>Table prefix:</td>
	<td><input type="text" name="db[tablepre]" size="20" value="uchome_"></td>
	<td>Can not be empty, default is uchome_</td>
	</tr>
	</table>

	<table class=button>
	<tr><td><input type="submit" id="sqlsubmit" name="sqlsubmit" value="Test database configuration"></td></tr>
	</table>
	<input type="hidden" name="formhash" value="$formhash">
	</form>
END;
	show_footer();

} elseif ($step == 3) {

	//链接数据库
	dbconnect();

	//安装数据库
	//获取最新的sql文
	$newsql = sreadfile($sqlfile);

	if($_SC['tablepre'] != 'uchome_') $newsql = str_replace('uchome_', $_SC['tablepre'], $newsql);//替换表名前缀

	//获取要创建的表
	$tables = $sqls = array();
	if($newsql) {
		preg_match_all("/(CREATE TABLE ([a-z0-9\_\-`]+).+?\s*)(TYPE|ENGINE)+\=/is", $newsql, $mathes);
		$sqls = $mathes[1];
		$tables = $mathes[2];
	}
	if(empty($tables)) {
		show_msg("Failed to get SQL statements, make sure SQL file $sqlfile   does exist");
	}

	$heaptype = $_SGLOBAL['db']->version()>'4.1'?" ENGINE=MEMORY".(empty($_SC['dbcharset'])?'':" DEFAULT CHARSET=$_SC[dbcharset]" ):" TYPE=HEAP";
	$myisamtype = $_SGLOBAL['db']->version()>'4.1'?" ENGINE=MYISAM".(empty($_SC['dbcharset'])?'':" DEFAULT CHARSET=$_SC[dbcharset]" ):" TYPE=MYISAM";
	$installok = true;
	foreach ($tables as $key => $tablename) {
		if(strpos($tablename, 'session')) {
			$sqltype = $heaptype;
		} else {
			$sqltype = $myisamtype;
		}
		$_SGLOBAL['db']->query("DROP TABLE IF EXISTS `$tablename`");
		if(!$query = $_SGLOBAL['db']->query($sqls[$key].$sqltype, 'SILENT')) {
			$installok = false;
			break;
		}
	}
	if(!$installok) {
		show_msg("<font color=\"blue\">Table ($tablename) autoinstall failed.</font><br />Error msg: ".mysql_error()."<br /><br />Please refer to $sqlfile, install the database manually, then continue the installation. <br /><br /><a href=\"?step=$step\">Retry</a>");
	} else {
		show_msg('All Tables have installed successfully, go to next step', ($step+1), 1);
	}

} elseif ($step == 4) {

	//插入默认数据
	dbconnect();
	$privacy = array(
		'view' => array(
			'index' => 0,
			'profile' => 0,
			'friend' => 0,
			'wall' => 0,
			'feed' => 0,
			'mtag' => 0,
			'event' => 0,
			'doing' => 0,
			'blog' => 0,
			'album' => 0,
			'share' => 0,
			'poll' => 0
		),
		'feed' => array(
			'doing' => 1,
			'blog' => 1,
			'upload' => 1,
			'share' => 1,
			'poll' => 1,
			'joinpoll' => 1,
			'thread' => 1,
			'post' => 1,
			'mtag' => 1,
			'event' => 1,
			'join' => 1,
			'friend' => 1,
			'comment' => 1,
			'show' => 1,
			'spaceopen' => 1,
			'credit' => 1,
			'invite' => 1,
			'task' => 1,
			'profile' => 1,
			'album' => 1,
			'click' => 1
		)
	);
	//config
	$datas = array(
		"('sitename', 'My Space')",
		"('template', 'default')",
		"('adminemail', 'webmaster@".$_SERVER['HTTP_HOST']."')",
		"('onlinehold', '1800')",
		"('timeoffset', '8')",
		"('maxpage', '100')",
		"('starcredit', '100')",
		"('starlevelnum', '5')",
		"('cachemode', 'database')",
		"('cachegrade', '0')",
		"('allowcache', '1')",
		"('allowdomain', '0')",
		"('allowrewrite', '0')",
		"('allowwatermark', '0')",
		"('allowftp', '0')",
		"('holddomain', 'www|*blog*|*space*|x')",
		"('mtagminnum', '5')",
		"('feedday', '7')",
		"('feedmaxnum', '100')",
		"('feedfilternum', '10')",
		"('importnum', '100')",
		"('maxreward', '10')",
		"('singlesent', '50')",
		"('groupnum', '8')",
		"('closeregister', '0')",
		"('closeinvite', '0')",
		"('close', '0')",
		"('networkpublic', '1')",
		"('networkpage', '1')",
		"('seccode_register', '1')",
		"('uc_tagrelated', '1')",
		"('manualmoderator', '1')",
		"('linkguide', '1')",
		"('showall', '1')",
		"('sendmailday', '0')",
		"('realname', '0')",
		"('namecheck', '0')",
		"('namechange', '0')",
		"('name_allowviewspace', '1')",
		"('name_allowfriend', '1')",
		"('name_allowpoke', '1')",
		"('name_allowdoing', '1')",
		"('name_allowblog', '0')",
		"('name_allowalbum', '0')",
		"('name_allowthread', '0')",
		"('name_allowshare', '0')",
		"('name_allowcomment', '0')",
		"('name_allowpost', '0')",
		"('showallfriendnum', '10')",
		"('feedtargetblank', '1')",
		"('feedread', '1')",
		"('feedhotnum', '3')",
		"('feedhotday', '2')",
		"('feedhotmin', '3')",
		"('feedhiddenicon', 'friend,profile,task,wall')",
		"('uc_tagrelatedtime', '86400')",
		"('privacy', '".serialize($privacy)."')",
		"('cronnextrun', '$_SGLOBAL[timestamp]')",
		"('my_status', '0')",
		"('maxreward', '10')",
		"('uniqueemail', '1')",
		"('updatestat', '1')",
		"('my_showgift', '1')",
		"('topcachetime', '60')",
		"('newspacenum', '3')"
	);
	$_SGLOBAL['db']->query("TRUNCATE TABLE ".tname('config'));
	$_SGLOBAL['db']->query("REPLACE INTO ".tname('config')." (var, datavalue) VALUES ".implode(',', $datas));

	//profield
	$datas = array(
		"('Liberty', 'text', '100', '0', '1')",
		"('Regional', 'text', '100', '0', '1')",
		"('hobby', 'text', '100', '0', '1')"
	);
	$_SGLOBAL['db']->query("TRUNCATE TABLE ".tname('profield'));
	$_SGLOBAL['db']->query("REPLACE INTO ".tname('profield')." (title,formtype,inputnum,manualmoderator,manualmember) VALUES ".implode(',', $datas));

	//用户组
	$datas = array();
	$datas['grouptitle'] = array('Webmaster', 'Info Manager', 'VIP', 'Restricted Member', 'Normal Member', 'Intermediate Member', 'Senior Member', 'No Posting', 'No Access');

	//核心设置
	$datas['gid'] = array(1, 2, 3, 4, 5, 6, 7, 8, 9);
	$datas['system'] = array(-1, -1, 1, 0, 0, 0, 0, -1, -1);
	$datas['explower'] = array(0, 0, 0, -999999999, 0, 100, 1000, 0, 0);
	$datas['banvisit'] = array(0, 0, 0, 0, 0, 0, 0, 0, 1);
	$datas['searchignore'] = array(1, 1, 1, 0, 0, 0, 1, 0, 0);
	$datas['videophotoignore'] = array(1, 1, 0, 0, 0, 0, 0, 0, 0);
	$datas['spamignore'] = array(1, 1, 1, 0, 0, 0, 0, 0, 0);

	$datas['color'] = array('red', 'blue', 'green', '', '', '', '', '', '');
	$datas['icon'] = array('image/group/admin.gif', 'image/group/infor.gif', 'image/group/vip.gif', '', '', '', '', '', '');

	//基本设置
	$datas['maxfriendnum'] = array(0, 0, 0, 10, 100, 200, 300, 1, 1);
	$datas['maxattachsize'] = array(0, 0, 0, 10, 20, 50, 100, 1, 1);
	$datas['postinterval'] = array(0, 0, 0, 300, 60, 30, 10, 9999, 9999);
	$datas['searchinterval'] = array(0, 0, 0, 600, 60, 30, 10, 9999, 9999);
	
	$datas['verifyevent'] = array(0, 0, 0, 1, 0, 0, 0, 1, 1);

	$datas['domainlength'] = array(1, 3, 3, 0, 0, 5, 3, 99, 99);
	$datas['closeignore'] = array(1, 1, 0, 0, 0, 0, 0, 0, 0);
	$datas['seccode'] = array(0, 0, 0, 1, 0, 0, 0, 1, 1);

	$datas['allowhtml'] = array(1, 1, 1, 0, 0, 0, 1, 0, 0);
	$datas['allowcss'] = array(1, 1, 1, 0, 0, 0, 1, 0, 0);
	$datas['allowviewvideopic'] = array(1, 1, 1, 0, 0, 0, 0, 0, 0);
	
	$datas['allowtopic'] = array(1, 1, 0, 0, 0, 0, 0, 0, 0);
	$datas['allowstat'] = array(1, 1, 0, 0, 0, 0, 0, 0, 0);
	
	foreach (array('comment','blog','poll','doing','upload','share','mtag','thread','post','poke','friend','click','event','magic', 'pm', 'myop') as $value) {
		$datas['allow'.$value] = array(1, 1, 1, 0, 1, 1, 1, 0, 0);
	}

	//管理权限
	//站点设置
	foreach (array('config','usergroup','credit','profilefield','profield','censor','ad','cache','block','template','backup','stat','cron','app', 'network','name','task','report', 'eventclass', 'magic','magiclog','topic', 'batch', 'delspace', 'spacegroup', 'spaceinfo', 'spacecredit', 'spacenote', 'ip', 'hotuser', 'defaultuser', 'click', 'videophoto', 'log') as $value) {
		$datas['manage'.$value] = array(1, 0, 0, 0, 0, 0, 0, 0, 0);
	}

	//信息管理
	foreach (array('tag','mtag','feed','share','doing', 'blog','album','comment','thread', 'event', 'poll') as $value) {
		$datas['manage'.$value] = array(1, 1, 0, 0, 0, 0, 0, 0, 0);
	}

	$keys = array_keys($datas);
	$newdatas = array();
	$g_count = count($datas['grouptitle']);
	for ($i=0; $i<$g_count; $i++) {
		$thes = array();
		foreach ($keys as $value) {
			$thes[] = $datas[$value][$i];
		}
		$newdatas[$i] = "(".simplode($thes).")";
	}
	$_SGLOBAL['db']->query("TRUNCATE TABLE ".tname('usergroup'));
	$_SGLOBAL['db']->query("REPLACE INTO ".tname('usergroup')." (".implode(',', $keys).") VALUES ".implode(',', $newdatas));

	//积分规则
	$ruls = array();
	//加积分
	$ruls[] = "('Activate Space', 'register', '0', '0', '1', '1', '10', '0', '0')";
	$ruls[] = "('Real-name Authentication', 'realname', '0', '0', '1', '1', '20', '0', '20')";
	$ruls[] = "('E-mail Authentication', 'realemail', '0', '0', '1', '1', '40', '0', '40')";
	$ruls[] = "('Successfully Invite', 'invitefriend', '4', '0', '20', '1', '10', '0', '10')";
	$ruls[] = "('Upload Avatar', 'setavatar', '0', '0', '1', '1', '15', '0', '15')";
	$ruls[] = "('Video Verification', 'videophoto', '0', '0', '1', '1', '40', '0', '40')";
	$ruls[] = "('Successfully Reported', 'report', '4', '0', '0', '1', '2', '0', '2')";
	$ruls[] = "('Update Status', 'updatemood', '1', '0', '3', '1', '3', '0', '3')";
	$ruls[] = "('Hot Info', 'hotinfo', '4', '0', '0', '1', '10', '0', '10')";
	$ruls[] = "('First Time Sign In', 'daylogin', '1', '0', '1', '1', '15', '0', '15')";
	$ruls[] = "('Visit Others Space', 'visit', '1', '0', '10', '1', '1', '2', '1')";
	$ruls[] = "('Poke', 'poke', '1', '0', '10', '1', '1', '2', '1')";
	$ruls[] = "('Leave a Message', 'guestbook', '1', '0', '20', '1', '2', '2', '2')";
	$ruls[] = "('Receive Message', 'getguestbook', '1', '0', '5', '1', '1', '2', '0')";
	$ruls[] = "('Post Note', 'doing', '1', '0', '5', '1', '1', '0', '1')";
	$ruls[] = "('Post Blog', 'publishblog', '1', '0', '3', '1', '5', '0', '5')";
	$ruls[] = "('Upload Picture', 'uploadimage', '1', '0', '10', '1', '2', '0', '2')";
	$ruls[] = "('Take Camshot', 'camera', '1', '0', '5', '1', '3', '0', '3')";
	$ruls[] = "('Post Thread', 'publishthread', '1', '0', '5', '1', '5', '0', '5')";
	$ruls[] = "('Reply to Thread', 'replythread', '1', '0', '10', '1', '1', '1', '1')";
	$ruls[] = "('Create Poll', 'createpoll', '1', '0', '5', '1', '2', '0', '2')";
	$ruls[] = "('Join Vote', 'joinpoll', '1', '0', '10', '1', '1', '1', '1')";
	$ruls[] = "('Create Activity', 'createevent', '1', '0', '1', '1', '3', '0', '3')";
	$ruls[] = "('Join Activity', 'joinevent', '1', '0', '1', '1', '1', '1', '1')";
	$ruls[] = "('Recommend Activity', 'recommendevent', '4', '0', '0', '1', '10', '0', '10')";
	$ruls[] = "('Add Share', 'createshare', '1', '0', '3', '1', '2', '0', '2')";
	$ruls[] = "('Comment', 'comment', '1', '0', '40', '1', '1', '1', '1')";
	$ruls[] = "('Get Commented', 'getcomment', '1', '0', '20', '1', '1', '1', '0')";
	$ruls[] = "('Install Application', 'installapp', '4', '0', '0', '1', '5', '3', '5')";
	$ruls[] = "('Use Application', 'useapp', '1', '0', '10', '1', '1', '3', '1')";
	$ruls[] = "('Show Attitude', 'click', '1', '0', '10', '1', '1', '1', '1')";
	//扣积分
	$ruls[] = "('Edit Real Name', 'editrealname', '0', '0', '1', '0', '5', '0', '0')";
	$ruls[] = "('Edit Email', 'editrealemail', '0', '0', '1', '0', '5', '0', '0')";
	$ruls[] = "('Delete Avatar', 'delavatar', '0', '0', '1', '0', '10', '0', '10')";
	$ruls[] = "('Generate Invitation Code', 'invitecode', '0', '0', '1', '0', '0', '0', '0')";
	$ruls[] = "('One Search', 'search', '0', '0', '1', '0', '1', '0', '0')";
	$ruls[] = "('Import Blog', 'blogimport', '0', '0', '1', '0', '10', '0', '0')";
	$ruls[] = "('Modify Domain', 'modifydomain', '0', '0', '1', '0', '5', '0', '0')";
	$ruls[] = "('Delete Blog', 'delblog', '0', '0', '1', '0', '10', '0', '10')";
	$ruls[] = "('Delete Note', 'deldoing', '0', '0', '1', '0', '2', '0', '2')";
	$ruls[] = "('Delete Picture', 'delimage', '0', '0', '1', '0', '4', '0', '4')";
	$ruls[] = "('Delete Poll', 'delpoll', '0', '0', '1', '0', '4', '0', '4')";
	$ruls[] = "('Delete Thread', 'delthread', '0', '0', '1', '0', '4', '0', '4')";
	$ruls[] = "('Delete Activity', 'delevent', '0', '0', '1', '0', '6', '0', '6')";
	$ruls[] = "('Delete Share', 'delshare', '0', '0', '1', '0', '4', '0', '4')";
	$ruls[] = "('Delete Message', 'delguestbook', '0', '0', '1', '0', '4', '0', '4')";
	$ruls[] = "('Delete Comment', 'delcomment', '0', '0', '1', '0', '2', '0', '2')";
	
	$_SGLOBAL['db']->query("INSERT INTO ".tname('creditrule')." (`rulename`, `action`, `cycletype`, `cycletime`, `rewardnum`, `rewardtype`, `credit`, `norepeat`, `experience`) VALUES ".implode(',', $ruls));
			
	$_SGLOBAL['db']->query("TRUNCATE TABLE ".tname('data'));
	//邮件设置
	$mails = array(
		'mailsend' => 1,
		'maildelimiter' => 0,
		'mailusername' => 1
	);
	data_set('mail', $mails);

	//缩略图设置
	$settings = array(
		'thumbwidth' => 100,
		'thumbheight' => 100,
		'watermarkpos' => 4,
		'watermarktrans' => 75
	);
	data_set('setting', $settings);
	
	//随便看看
	$network = array(
		'blog' => array('hot1'=>3, 'cache'=>600),
		'pic' => array('hot1'=>3, 'cache'=>700),
		'thread' => array('hot1'=>3, 'cache'=>800),
		'event' => array('cache'=>900),
		'poll' => array('cache'=>500),
	);
	data_set('network', $network);

	//计划任务
	$datas = array(
		"1, 'system', 'Update Access Stats', 'log.php', $_SGLOBAL[timestamp], $_SGLOBAL[timestamp], -1, -1, -1, '0	5	10	15	20	25	30	35	40	45	50	55'",
		"1, 'system', 'Clean Feed', 'cleanfeed.php', $_SGLOBAL[timestamp], $_SGLOBAL[timestamp], -1, -1, 3, '4'",
		"1, 'system', 'Clean Notification', 'cleannotification.php', $_SGLOBAL[timestamp], $_SGLOBAL[timestamp], -1, -1, 5, '6'",
		"1, 'system', 'Synchronize UC feeds', 'getfeed.php', $_SGLOBAL[timestamp], $_SGLOBAL[timestamp], -1, -1, -1, '2	7	12	17	22	27	32	37	42	47	52'",
		"1, 'system', 'Clean Trace', 'cleantrace.php', $_SGLOBAL[timestamp], $_SGLOBAL[timestamp], -1, -1, 2, '3'"
	);
	$_SGLOBAL['db']->query("TRUNCATE TABLE ".tname('cron'));
	$_SGLOBAL['db']->query("INSERT INTO ".tname('cron')." (available, type, name, filename, lastrun, nextrun, weekday, day, hour, minute) VALUES (".implode('),(', $datas).")");

	//用户任务
	$datas = array();
	$datas[] = "1, 'Update Avatar','Avatar is your personal photo.<br>You\'ll be surprising: <br>Our system will recommend you some new friends.<br>Do it now!', 'avatar.php', 1, '', 0, 20, 'image/task/avatar.gif'";
	$datas[] = "1, 'Complete Profile','Please complete your profile. <br>You\'ll be found by more friends, and system will also help you to look for friends.', 'profile.php', '', 2, 0, 20, 'image/task/profile.gif'";
	$datas[] = "1, 'Publish Your First Blog', 'Publish your first blog now.<br>To share your feelings of life.', 'blog.php', 3, '', 0, 5, 'image/task/blog.gif'";
	$datas[] = "1, 'Add 5 Friends', 'Your blogs and pictures will be spread out be friends;<br>You can also view latest status of your friends.<br>This function will make your cyber life on our site more colorful.', 'friend.php', 4, '', 0, 50, 'image/task/friend.gif'";
	$datas[] = "1, 'Verify and Activite Email', 'Fill in a valid email address and get verified.<br>Then you can retrieve your lost password;<br>And get notifications.<br>This is really helpful and necessary.', 'email.php', 5, '', 0, 10, 'image/task/email.gif'";
	$datas[] = "1, 'Invite 10 New Friends', 'Send invitation to your friends to join you on our site by Email or other Instant Messager.', 'invite.php', 6, '', 0, 100, 'image/task/friend.gif'";
	$datas[] = "1, 'Daily Gift Package', 'Log in to your profile every day and get your credits every day.<br>A free guideline of this weeks <b>hot blog ranking</b> will be received for free.', 'gift.php', 99, 'day', 0, 5, 'image/task/gift.gif'";

	$_SGLOBAL['db']->query("TRUNCATE TABLE ".tname('task'));
	$_SGLOBAL['db']->query("INSERT INTO ".tname('task')." (`available`, `name`, `note`, `filename`, `displayorder`, `nexttype`, `nexttime`, `credit`, `image`) VALUES (".implode('),(', $datas).")");

	//活动分类
	$datas = array(
		"1, 'Life/Party', 0, 'Charge:\r\nLocation:\r\nDress:\r\nContact:\r\nNote:', 1",
		"2, 'Travel/Out', 0, 'Route:\r\nCharge:\r\nGear:\r\nTransport:\r\nLocation:\r\nContact:\r\nNote:', 2",
		"3, 'Game/Sport', 0, 'Charge:\r\nLocation:\r\nDress:\r\nPlace:\r\nContact:\r\nNote:', 4",
		"4, 'Movie/Show', 0, 'Description:\r\nCharge:\r\nLocation:\r\nContact:\r\nNote:', 3",
		"5, 'Education/Seminar', 0, 'Organizer:\r\nTheme:\r\nCharge:\r\nLocation:\r\nContact:\r\nNote:', 5",
		"6, 'Other', 0, '', 6"
	);	
	$_SGLOBAL['db']->query("TRUNCATE TABLE ".tname('eventclass'));
	$_SGLOBAL['db']->query("INSERT INTO ".tname('eventclass')." (classid, classname, poster, template, displayorder) VALUES (".implode('),(', $datas).")");
	
	//道具
	$datas = array();
	$datas[] = "'invisible', 'Cloak', 'Make you invisible when logged in, functional within 24 hours.', '5', '50', '86400', '10', '86400', '1'";
	$datas[] = "'friendnum', 'Increase Friend Count', 'Increase 10 more friends.', '3', '30', '86400', '999', '0', '1'";
	$datas[] = "'attachsize', 'Increase Attachment Space', 'Increase 10M more space for one usage of this prop.', '3', '30', '86400', '999', '0', '1'";
	$datas[] = "'thunder', 'Thunder', 'Send an announcement and tell everyone on site that you are online now.', '5', '500', '86400', '5', '86400', '1'";
	$datas[] = "'updateline', 'Buoy', 'Update publish time of selected object to current.', '5', '200', '86400', '999', '0', '1'";
		
	$datas[] = "'downdateline', 'Time Machine', 'Modify publish time of selected object to an earlier time.', '5', '250', '86400', '999', '0', '1'";		
	$datas[] = "'color', 'Color Light', 'Color selected title.', '5', '50', '86400', '999', '0', '1'";
	$datas[] = "'hot', 'Hot Light', 'Increase popular value of selected content.', '5', '50', '86400', '999', '0', '1'";
	$datas[] = "'visit', 'Visit', 'Select 10 friends randomly and poke, leave message or visit their space.', '2', '20', '86400', '999', '0', '1'";
	$datas[] = "'icon', 'Rainbow Egg', 'Add rainbow egg ahead of selected title (maximum 8 icons).', '2', '20', '86400', '999', '0', '1'";
		
	$datas[] = "'flicker', 'Flicker', 'Flash up text in comment or message.', '3', '30', '86400', '999', '0', '1'";
	$datas[] = "'gift', 'Red Envelope', 'Plant a red envelope in your space, anyone find it will get some credits.', '2', '20', '86400', '999', '0', '1'";
	$datas[] = "'superstar', 'Superstar', 'Add superstar sign on your avatar in your space.', '3', '30', '86400', '999', '0', '1'";
	$datas[] = "'viewmagiclog', 'Gossip Mirror', 'Find out what props specified user used lately.', '5', '100', '86400', '999', '0', '1'";
	$datas[] = "'viewmagic', 'Perspective Mirror', 'Find out what props specifie user own.', '5', '100', '86400', '999', '0', '1'";
		
	$datas[] = "'viewvisitor', 'Voyeuristic mirror', 'Find out latest 10 spaces specfied user visited.', '5', '100', '86400', '999', '0', '1'";
	$datas[] = "'call', 'Call', 'Sed notification to your friends, invite them to invite specfied content.', '5', '50', '86400', '999', '0', '1'";
	$datas[] = "'coupon', 'Coupon','Use coupon to pay less when purchasing props.', '0', '0', '0', '0', '0', '1'";
	$datas[] = "'frame', 'Frame', 'Add frame to your photo.', '3', '30', '86400', '999', '0', '1'";
	$datas[] = "'bgimage', 'Background', 'Add letter paper background to specified object.', '3', '30', '86400', '999', '0', '1'";
		
	$datas[] = "'doodle', 'Doodle ', 'Use doodle on comment and message board.', '3', '30', '86400', '999', '0', '1'";
	$datas[] = "'anonymous', 'Anonymous', 'Hide your name in specified place.', '5', '50', '86400', '999', '0', '1'";
	$datas[] = "'reveal', 'Magic mirror', 'Find out real identity of anonymous user.', '5', '100', '86400', '999', '0', '1'";
	$datas[] = "'license', 'License', 'Use license to transfer props.', '1', '10', '3600', '999', '0', '1'";
	$datas[] = "'detector', 'Detector', 'Detect which space berried with red envelope', '1', '10', '86400', '999', '0', '1'";
	
	$_SGLOBAL['db']->query("TRUNCATE TABLE ".tname('magic'));
	$_SGLOBAL['db']->query("INSERT INTO ".tname('magic')."(`mid`, `name`, `description`, `experience`, `charge`, `provideperoid`, `providecount`, `useperoid`, `usecount`) VALUES (".implode('),(', $datas).")");		

	//表态
	$datas = array(
		"'1', 'Pass By', 'luguo.gif', 'blogid'",
		"'2', 'Shocked', 'leiren.gif', 'blogid'",
		"'3', 'Handshake', 'woshou.gif', 'blogid'",
		"'4', 'Flower', 'xianhua.gif', 'blogid'",
		"'5', 'Crap', 'jidan.gif', 'blogid'",
		
		"'6', 'Beautiful', 'piaoliang.gif', 'picid'",
		"'7', 'Cool', 'kubi.gif', 'picid'",
		"'8', 'Shocked', 'leiren.gif', 'picid'",
		"'9', 'Flower', 'xianhua.gif', 'picid'",
		"'10', 'Egg', 'jidan.gif', 'picid'",
		
		"'11', 'Funny', 'gaoxiao.gif', 'tid'",
		"'12', 'Confused', 'mihuo.gif', 'tid'",
		"'13', 'Shocked', 'leiren.gif', 'tid'",
		"'14', 'Flower', 'xianhua.gif', 'tid'",
		"'15', 'Crap', 'jidan.gif', 'tid'"
	);
	$_SGLOBAL['db']->query("TRUNCATE TABLE ".tname('click'));
	$_SGLOBAL['db']->query("INSERT INTO ".tname('click')." (clickid, `name`, icon, idtype) VALUES (".implode('),(', $datas).")");

	show_msg('System default data is loaded, enter the next step', ($step+1), 1);

} elseif ($step == 5) {

	//更新缓存
	dbconnect();
	include_once(S_ROOT.'./source/function_cache.php');

	config_cache();
	usergroup_cache();
	profilefield_cache();
	profield_cache();
	censor_cache();
	block_cache();
	eventclass_cache();
	magic_cache();
	click_cache();
	task_cache();
	ad_cache();
	creditrule_cache();
	userapp_cache();
	app_cache();
	network_cache();

	$msg = <<<EOF
	<form method="post" action="$theurl">
	<table>
	<tr><td colspan="2">Script data installation is complete!<br><br>
	Finally, please enter your username and password in UCenter<br> The system will automatically create the first space for you, and assign you as administrator!
	</td></tr>
	<tr><td>Username</td><td><input type="text" name="username" value="" size="30"></td></tr>
	<tr><td>Password</td><td><input type="password" name="password" value="" size="30"></td></tr>
	<tr><td></td><td><input type="submit" name="opensubmit" value="Create Admin Space"></td></tr>
	</table>
	<input type="hidden" name="formhash" value="$formhash">
	</form>
EOF;

	show_msg($msg, 999);
}

//页面头部
function show_header() {
	global $_SGLOBAL, $nowarr, $step, $theurl, $_SC;

	$nowarr[$step] = ' class="current"';
	print<<<END
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
	<meta http-equiv="Content-Type" content="text/html; charset=$_SC[charset]" />
	<title>UCenter Home Installation Wizard - Translated by msg2me.com</title>
	<style type="text/css">
	{font-size:10px; font-family: Verdana, Arial, Helvetica, sans-serif; line-height: 1.5em; word-break: break-all; }
	body { text-align:center; margin: 0; padding: 0; background: #F5FBFF; }
	.bodydiv { margin: 40px auto 0; width:720px; text-align:left; border: solid #86B9D6; border-width: 5px 1px 1px; background: #FFF; }
	h1 { font-size: 18px; margin: 1px 0 0; line-height: 50px; height: 50px; background: #E8F7FC; color: #5086A5; padding-left: 10px; }
	#menu {width: 100%; margin: 10px auto; text-align: center; }
	#menu td { height: 30px; line-height: 30px; color: #999; border-bottom: 3px solid #EEE; }
	.current { font-weight: bold; color: #090 !important; border-bottom-color: #F90 !important; }
	.showtable { width:100%; border: solid; border-color:#86B9D6 #B2C9D3 #B2C9D3; border-width: 3px 1px 1px; margin: 10px auto; background: #F5FCFF; }
	.showtable td { padding: 3px; }
	.showtable strong { color: #5086A5; }
	.datatable { width: 100%; margin: 10px auto 25px; }
	.datatable td { padding: 5px 0; border-bottom: 1px solid #EEE; }
	input { border: 1px solid #B2C9D3; padding: 5px; background: #F5FCFF; }
	.button { margin: 10px auto 20px; width: 100%; }
	.button td { text-align: center; }
	.button input, .button button { border: solid; border-color:#F90; border-width: 1px 1px 3px; padding: 5px 10px; color: #090; background: #FFFAF0; cursor: pointer; }
	#footer { font-size: 10px; line-height: 40px; background: #E8F7FC; text-align: center; height: 38px; overflow: hidden; color: #5086A5; margin-top: 20px; }
	</style>
	<script type="text/javascript">
	function $(id) {
		return document.getElementById(id);
	}
	//添加Select选项
	function addoption(obj) {
		if (obj.value=='addoption') {
			var newOption=prompt('Please enter:','');
			if (newOption!=null && newOption!='') {
				var newOptionTag=document.createElement('option');
				newOptionTag.text=newOption;
				newOptionTag.value=newOption;
				try {
					obj.add(newOptionTag, obj.options[0]); // doesn't work in IE
				}
				catch(ex) {
					obj.add(newOptionTag, obj.selecedIndex); // IE only
				}
				obj.value=newOption;
			} else {
				obj.value=obj.options[0].value;
			}
		}
	}
	</script>
	</head>
	<body id="append_parent">
	<div class="bodydiv">
	<h1>UCenter Home Installation Wizard</h1>
	<div style="width:90%;margin:0 auto;">
	<table id="menu">
	<tr>
	<td{$nowarr[0]}>1.Verify Configuration</td>
	<td{$nowarr[1]}>2.Set UCenter Information</td>
	<td{$nowarr[2]}>3.Connect to the database</td>
	<td{$nowarr[3]}>4.Creating Tables</td>
	<td{$nowarr[4]}>5.Setup Default Data</td>
	<td{$nowarr[5]}>6.Install Complete</td>
	</tr>
	</table>
END;
}

//页面顶部
function show_footer() {
	print<<<END
	</div>
	<iframe id="phpframe" name="phpframe" width="0" height="0" marginwidth="0" frameborder="0" src="about:blank"></iframe>
	<div id="footer">&copy; Comsenz Inc. 2001-2009 u.discuz.net</div><div id="footer">&copy; 2010 Translated by <a href="http://www.msg2me.com" target_blank>msg2me.com</a></div>
	</div>
	<br>
	</body>
	</html>
END;
}


//显示
function show_msg($message, $next=0, $jump=0) {
	global $theurl;

	$nextstr = '';
	$backstr = '';

	obclean();
	if(empty($next)) {
		$backstr .= "<a href=\"javascript:history.go(-1);\">Back to the previous step</a>";
	} elseif ($next == 999) {
	} else {
		$url_forward = "$theurl?step=$next";
		if($jump) {
			$nextstr .= "<a href=\"$url_forward\">Please wait ...</a><script>setTimeout(\"window.location.href ='$url_forward';\", 1000);</script>";
		} else {
			$nextstr .= "<a href=\"$url_forward\">Next Step</a>";
			$backstr .= "<a href=\"javascript:history.go(-1);\">Previous Step</a>";
		}
	}

	show_header();
	print<<<END
	<table>
	<tr><td>$message</td></tr>
	<tr><td>&nbsp;</td></tr>
	<tr><td>$backstr $nextstr</td></tr>
	</table>
END;
	show_footer();
	exit();
}

//检查权限
function checkfdperm($path, $isfile=0) {
	if($isfile) {
		$file = $path;
		$mod = 'a';
	} else {
		$file = $path.'./install_tmptest.data';
		$mod = 'w';
	}
	if(!@$fp = fopen($file, $mod)) {
		return false;
	}
	if(!$isfile) {
		//是否可以删除
		fwrite($fp, ' ');
		fclose($fp);
		if(!@unlink($file)) {
			return false;
		}
		//检测是否可以创建子目录
		if(is_dir($path.'./install_tmpdir')) {
			if(!@rmdir($path.'./install_tmpdir')) {
				return false;
			}
		}
		if(!@mkdir($path.'./install_tmpdir')) {
			return false;
		}
		//是否可以删除
		if(!@rmdir($path.'./install_tmpdir')) {
			return false;
		}
	} else {
		fclose($fp);
	}
	return true;
}

?>
